#include "konto.hh"


TKonto::TKonto(int Nr, int Kunde) 
{
  Acl = new TAcl(Kunde);
  Aktionen = new TList<TTransaktion>;
  KontoNr=Nr;
  KontoStand=0;
}



TKonto::TKonto(ifstream &in)
{

  Aktionen = new TList<TTransaktion>;
  
  int Zeilenlaenge=1024; // Maximale Zeilenlaenge betraegt 1024
  char puffer [ Zeilenlaenge ];
  for (int i=0; i<=2;i++)
    {
      in.getline(puffer,Zeilenlaenge);            
      switch (i)
	{
	case 0 : sscanf(puffer,"%d",  &KontoNr); break;     //1.Zeile
	case 1 : sscanf(puffer,"%lf",  &KontoStand); break; //2.Zeile
	case 2 : // 3.Zeile Beginn der Transaktionen 
	  {
	    bool kontodata=true;
	    while(kontodata)
	      {
		if (!strcmp(puffer,"TRANSAKTION")) 
		  {
		    TTransaktion Akt(in);
		    Aktionen->addElement(Akt);
		  }
		if (!strcmp(puffer,"ACL"))  
		  { 
		    Acl = new TAcl(in);
		    kontodata=false; 		    
		  }		
		else in.getline(puffer,Zeilenlaenge);
	      }
	  }
	break;
	}
    }        
}


TKonto::~TKonto() 
{ 
  delete Aktionen;
  delete Acl;
}

TKonto::TKonto( const TKonto& Kt ) 
{
  Acl = new TAcl(*Kt.getAcl());
  Aktionen = new TList<TTransaktion>(*Kt.getAktionen());
  KontoNr = Kt.getKontoNr();
  KontoStand = Kt.getKontoStand();
}

double TKonto::getKontoStand() const { return KontoStand; }

void TKonto::addAktion(const TTransaktion &A) { 
  if (A.getSource()== getKontoNr())
    // Abzug von diesem Konto
    KontoStand-=A.getBetrag();
  if (A.getTarget()== getKontoNr())
    // Ueberweisung auf dieses Konto
    if (A.getModus()!=BarAus) KontoStand+=A.getBetrag();
    else KontoStand-=A.getBetrag();
  Aktionen->addElement(A);   
}

int TKonto::getKontoInhaber() const {return Acl->getOwner();}

int TKonto::getKontoNr() const { return KontoNr; }
  
TList<TTransaktion>* TKonto::getAktionen()  const { return Aktionen;}











