#include "transaktion.hh"

TTransaktion::TTransaktion(int S, int T, double B, int M, const TString &Z)
{
	init(S,T,B,M,Z);
}


TTransaktion::TTransaktion( const TTransaktion &T)
{
	init(T.getSource(),T.getTarget(),T.getBetrag(),T.getModus(),T.getZweck());
}


TTransaktion::TTransaktion(ifstream &in)
{
  int Zeilenlaenge=1024;      // Maximale Zeilenlaenge betraegt 1024
  int S; int T; double B; char SM[Zeilenlaenge]; int M=0; char Z[Zeilenlaenge];

  
  char puffer[Zeilenlaenge]; 
  for (int i=0; i<=4;i++)
    {
      in.getline(puffer,Zeilenlaenge);       
      switch (i)
	{
	case 0 :sscanf(puffer,"%d",  &S)    ;break; //1.Zeile
	case 1 :sscanf(puffer,"%d",  &T)    ;break; //2.Zeile
	case 2 :sscanf(puffer,"%lf", &B)    ;break; //3.Zeile
	case 3 :
	  {
	    sscanf(puffer,"%s",  (char*) &SM);         //4.Zeile
	    if (!strcmp(SM,"Dauerauftrag"))  M=DauerAuftrag;
	    if (!strcmp(SM,"Bareinzahlung")) M=BarEin;
	    if (!strcmp(SM,"Barauszahlung")) M=BarAus;
	    if (!strcmp(SM,"Ueberweisung"))  M=Ueber;
	    
	  }
	break;
	case 4 :strcpy(Z,puffer); break; //5.Zeile
	}
    }      
  init(S,T,B,M,Z);
}


void TTransaktion::init(int S, int T, double B, int M, const TString &Z)
{
	Source=S; Target=T; Betrag=B; Modus=M; Status=0; Zweck = Z;  
}

TTransaktion::~TTransaktion()
{  
}
  
int TTransaktion::getModus() const
{
  return Modus;
}

double TTransaktion::getBetrag() const
{
  return Betrag;
}

int TTransaktion::getSource() const
{ return Source;
}

int TTransaktion::getTarget() const
{
  return Target;
}

TString TTransaktion::getZweck() const
{
  return Zweck;
}

int TTransaktion::getStatus() const
{
  return Status;
}

void TTransaktion::mutateStatus(int S)
{
  Status=S;
}





