#ifndef __TSOCKET_HH
#define __TSOCKET_HH
//
//  Project   : libmisc
//  File      : TSocket.hh
//  Author    : Ronald Kriemann
//  Purpose   : class for socket-based communication
//

#include "TString.hh"

//
// baseclass for socketbased communication (AF_INET, not AF_UNIX)
// expects an existing socket to be able to read and write
//
class TSocket
{
protected:
	// used socket
	int    sd;

	// port to connect
	uint   portNumber;

public:
	// constructor
	TSocket ( int s = -1 );
	
	// destructor
	virtual ~TSocket ();

	// init socket descriptor
	int initSocket ();

	// close socket
	int close ();

	// IO
	int read ( TString &string );
	int write ( const TString &string );

	// IO with operators
	TSocket & operator << ( const TString &string );

	// return diff. status 
	const bool canRead () const;
	const bool canWrite () const;

	// access port
	const uint & getPort () const;
	void setPort ( const uint & port );
};

#endif  // TSOCKET_HH
