#ifndef __BASE64_HH
#define __BASE64_HH
//
//  Project   : libmisc
//  File      : base64.hh
//  Author    : Christian Rost / Ronald Kriemann
//  Purpose   : class for base64 encoding and decoding
//

#include "defines.hh"
#include "TString.hh"

//
// class for base64 en- and decoding
// 
class TBase64 
{
protected:
	// the base64 char
	static char     base64CharArr[128];
	static TString  base64CharStr;

private:
    // hide copy constructor and operator
    TBase64 ( const TBase64 & );
    void operator = ( const TBase64 & );
    
public:  
	// constructor
	TBase64();

	// encode bytestream into base64
	static void encode ( uchar output[], const uchar input[], int len );
	static void encode ( TString &output, const TString &input );
	static TString encode ( const TString &input );

	// decode base64 to bytestream
	static int decode ( uchar output[], const uchar input[] );
	static int decode ( TString &output, const TString &input );
	static TString decode( const TString &input ); 
};


#endif  // __BASE64_HH

