#ifndef __MESSAGE_HH
#define __MESSAGE_HH
//
//  Project   : besy
//  File      : message.hh
//  Author    : Ronald Kriemann / Christian Rost
//  Purpose   : class for a message between commu- and bank-server
//  Date      : 04.06.1997
//  Changes   : 
//

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "msgdata.hh"

//
// Klasse fuer String-Botschaften in der MessageQueue
// Eine StringMessage hat die Form: Type Daten$Type Daten$Type Daten
// Wobei Type: 1 = Nachfolgendes Datenelement vom Typ: int
//             2 =        "           "        "   " : double
//             3 =        "           "        "   " : char*
//             4 =        "           "        "   " : TString

// Und $ Beliebieges Trennzeichen 
//
class TMessage
{
protected:
    // Maximale Laenge fuer die Ascii-Repreasentation einer Message
    char     buffer[4096];
    int      sizeOfMsg;

    MSGData *pData;

    // Trennzeichen
    char     limiter;

public:
	// Konstruktor
	TMessage ();

    ~TMessage();

	// Baut String-Message aus den Daten
    // Fuer die Bank-Commuserver-Verbindung
	char* buildBankMsg ( MSGData &data );

    // Baut String-Message aus den Daten
    // Fuer die Client-Commuserver-Verbindung
	char* buildClientMsg ( MSGData &data );

    char* getMsg ();

    // Haengt ein int-Wert an den Datenstring
    void addData (int data);

    // Haengt ein float-Wert an den Datenstring
    void addData (double data);

    // Haengt ein String an den Datenstring
    void addData (const char* data);
    
    // Haengt ein String (TString) an den Datenstring
    void addData (const TString &data);

    MSGData& getData (const char* msg);
    
    MSGData* extractData (int elements, const char* msg);

    // liefert Laenge des DatenElements;
    int getLength (const char* msg);
};

#endif // TMESSAGE




