//
//  Project   : besy
//  File      : msgdata.cc
//  Author    : Ronald Kriemann
//  Purpose   : class which holds all data for a msg for the bankserver
//

#include <iostream.h>

#include "msgdata.hh"

//
// constructor
//
MSGData::MSGData () 
{ 
    clear(); 	  
}

//
// destructor
//
MSGData::~MSGData ()
{}

//
// methods for setting and getting the diff. values and
// asking if they where set
//

int
MSGData::getKundenNr () const
{
    return (nKundenNr);
}

void
MSGData::setKundenNr ( int nr ) 
{ 
    nKundenNr = nr; 
    bWasSet[KUNDENNR] = TRUE; 
}

bool
MSGData::hasKundenNr () const
{
    return (bWasSet[KUNDENNR]);
}

char*
MSGData::getKundenPwd ()
{
    return (szKundenPwd);
}

void
MSGData::setKundenPwd ( const char* pwd ) 
{ 
    strcpy( szKundenPwd, pwd );
    if (strlen(pwd))
        bWasSet[KUNDENPWD] = TRUE; 	
}

bool
MSGData::hasKundenPwd () const
{
    return (bWasSet[KUNDENPWD]);
}

char*
MSGData::getKundenname () 
{ 
    if (bWasSet[KUNDENNAME]) 
		return (szKundenname) ;
    else return "";
}

void
MSGData::setKundenname ( const char* name ) 
{ 
    if (strlen(name)!=0)
    {
        strcpy( szKundenname, name );
        if (strlen(name))
            bWasSet[KUNDENNAME] = TRUE;	       
    }
}

bool
MSGData::hasKundenname () const
{
    return (bWasSet[KUNDENNAME]);
}

int
MSGData::getKontoNr () const
{
    return (nKontoNr);
}

void
MSGData::setKontoNr ( int nr ) 
{ 
    nKontoNr = nr; 
    bWasSet[KONTONR] = TRUE; 
}

bool
MSGData::hasKontoNr () const
{
    return (bWasSet[KONTONR]);
}

double
MSGData::getBetrag () const
{
    return (fBetrag);
}

void
MSGData::setBetrag ( double betrag ) 
{
    fBetrag = betrag;
    if (!betrag==0)
        bWasSet[BETRAG] = TRUE;
}

bool
MSGData::hasBetrag () const
{
    return (bWasSet[BETRAG]);
}

int
MSGData::getZielKontoNr () const
{
    return (nZielKontoNr);
}

void
MSGData::setZielKontoNr ( int nr ) 
{ 
    nZielKontoNr = nr; 
    if (!nr==0)
        bWasSet[ZIELKONTONR] = TRUE; 
}

bool
MSGData::hasZielKontoNr () const
{
    return (bWasSet[ZIELKONTONR]);
}

char*
MSGData::getZweck ()
{
    return (szZweck);
}

void
MSGData::setZweck ( const char* zweck ) 
{ 
    strcpy( szZweck, zweck );
    if (strlen(zweck))
        bWasSet[ZWECK] = TRUE; 
}

bool
MSGData::hasZweck () const
{
    return (bWasSet[ZWECK]);
}

char*
MSGData::getZielname ()
{
    return (szZielname);
}

void
MSGData::setZielname ( const char* name ) 
{ 
    strcpy( szZielname, name );
    if (strlen(name))
		bWasSet[ZIELNAME] = TRUE; 
}
         
int
MSGData::getZielnummer ()
{
    return (nZielnummer);
}

void
MSGData::setZielnummer ( int nummer ) 
{ 
    nZielnummer=nummer;
    if (!nummer==0)
        bWasSet[ZIELNUMMER] = TRUE; 
}

bool
MSGData::hasZielnummer () const
{
    return (bWasSet[ZIELNUMMER]);
}
  
bool
MSGData::hasZielname () const
{
    return (bWasSet[ZIELNAME]);
}

Operation
MSGData::getOperation() const
{
    return nOp;
}

void
MSGData::setOperation(Operation o)
{
    nOp=o;
}

bool
MSGData::hasOperation () const
{
    return nOp!=NOOP;
}

int
MSGData::getRechtAbheben () const
{
    return nRechtAbheben;
}

void
MSGData::setRechtAbheben (int value)
{
    nRechtAbheben=value;
    bWasSet[RECHTABHEBEN]=TRUE;
}

int
MSGData::getRechtKontoauszug () const
{
    return nRechtKontoauszug;
}

void
MSGData::setRechtKontoauszug(int value)
{
    nRechtKontoauszug=value;
    bWasSet[RECHTKONTOAUSZUG]=TRUE;
}

bool
MSGData::hasRechtAbheben() const
{
    return (bWasSet[RECHTABHEBEN]);
}

bool
MSGData::hasRechtKontoauszug() const
{
    return (bWasSet[RECHTABHEBEN]);
} 

const int
MSGData::getSerialNo () const
{
    return serialNo;
}

void
MSGData::setSerialNo ( int s )
{
    serialNo = s;
    
    if (serialNo >= 0)
        bWasSet[SERIALNO] = TRUE;
    
}

const bool
MSGData::hasSerialNo () const
{
    return bWasSet[SERIALNO];
}


const TString & 
MSGData::getCoinIDs () const
{
  return coinIds;
}

void 
MSGData::setCoinIDs ( const TString &arrID )
{  
  coinIds=arrID; 
}

const bool 
MSGData::hasCoinIDs () const
{
    return bWasSet[COINIDS];
}



const TString &
MSGData::getCoinStr () const
{
    return coinStr;
}

void
MSGData::setCoinStr ( const TString & string )
{
    coinStr = string;
    if (coinStr.length() > 0)
        bWasSet[COINSTR] = TRUE;
}

const bool
MSGData::hasCoinStr () const
{
    return bWasSet[COINSTR];
}
    
//
// clears all information (except Name,Login,Ktnr)
//
void
MSGData::clear () 
{
    uint  i;
    
    // memset( szKundenPwd, 0, sizeof(szKundenPwd) );
    // memset( szKundenname, 0, sizeof(szKundenname) );
	  				  
    nOp = NOOP;

    fBetrag           = 0.0;
    nZielKontoNr      = 0;
    nRechtAbheben     = FALSE;
    nRechtKontoauszug = 0;
    // nKontoNr          = 0;
    nZielnummer       = 0;
    memset( szZweck, 0, sizeof(szZweck) );
    memset( szZielname, 0, sizeof(szZielname) );

    serialNo = -1;
    coinStr = "";
    
    for (i = 3; i < (sizeof(bWasSet)/sizeof(bool)); i++)
        bWasSet[i] = FALSE;
}

//
// output
//
ostream&
operator << ( ostream& os, const MSGData& msgData ) 
{
    os << "Operation     : ";
    switch (msgData.nOp)
    {
        case LOGIN:       cout << "LOGIN"    << endl; break;
        case ONELOGIN:    cout << "ONELOGIN" << endl; break;
        case KSTAND:      cout << "KSTAND"   << endl; break;
        case KAUSZ:       cout << "KAUSZ"    << endl; break;
        case UEBERW:      cout << "UEBERW"   << endl; break;
        case RECHTE:      cout << "RECHTE"   << endl; break;
        case RSA:         cout << "RSA"      << endl; break;
        case ENDE:        cout << "ENDE"     << endl; break;
        case CHECKSERIAL: cout << "CHECKSERIAL" << endl; break;
        case SIGNCOIN :   cout << "SIGNCOIN" << endl; break;

        default:
        case NOOP :      cout << "NOOP"     << endl; break;
    }// switch
    
    os << "Kundennummer  : " << msgData.nKundenNr         << endl
       << "Kundenname    : " << msgData.szKundenname      << endl
       << "Kundenpwd     : " << msgData.szKundenPwd       << endl
       << "Kontonummer   : " << msgData.nKontoNr          << endl
       << "Betrag        : " << msgData.fBetrag           << endl
       << "Zielkontonr   : " << msgData.nZielKontoNr      << endl
       << "Zweck         : " << msgData.szZweck           << endl
       << "Zielname      : " << msgData.szZielname        << endl
       << "Zielnummer    : " << msgData.nZielnummer       << endl
       << "RechtAbheben  : " << msgData.nRechtAbheben     << endl
       << "RechtKontoaus : " << msgData.nRechtKontoauszug << endl
       << "Serial No     : " << msgData.serialNo          << endl
       << "Coin String   : lenght = " << msgData.coinStr.length() << endl;
    
    return os;
}
