#ifndef __SCANNER_HH
#define __SCANNER_HH
//
//  Project   : libmisc
//  File      : scanner.hh
//  Author    : Ronald Kriemann / Christian Rost
//  Purpose   : class for a lex. scanner
//  Date      : 14.05.1997
//  Changes   : 02.06.1997 - Token hinzugefuegt 
//

#include "../misc/defines.hh"
#include "../misc/TString.hh"

// possible tokens
enum Token 
{ 
	tokNothing, tokEOL, 
	tokInt, tokFloat, 
	tokKTNR, tokNAME, tokPASSWORT, tokONEPW, tokOPKSTAND, tokOPKAUSZ,
	tokOPUEBERW,tokOPRECHTE, tokOP, tokZKTNR, tokZNR, tokNUMMER,
	tokZNAME, tokBETRAG, tokZWECK, tokENDE, 
	tokADD, tokSUB, tokABHEBEN, tokKONTOAUSZUG, tokDot,
    tokOPSignCoin
};

//
// this scanner take a string and scans for given types 
// (vertex, frontier etc). if one is found, the token and value 
// is returned in the given object data
//
class Scanner
{
public:
	// class for dataexchange
	class TokenData
    {
	public:
		// wich token
		Token  token;

		// data of this token
		union {
			int    nInt;
			TFloat fFloat;
			char   szString[16384];
		};
	};

protected:
	// string which we scan
	TString szString;
    
	// act. position in string
	int     nPos;

public:
	// constructor
	Scanner ( const TString & string );
	// destructor
	~Scanner ();

	// returns next token and sets value of token
	int nextToken ( TokenData & data );

	// tries to read an integer and gives it back
	int getInt ( int & nInt );

	// tries to read an string, without EOL-char or other spaces on the end
	void getString ( char *string );

	// converts alpha char in digit
	int alpha2digit ( char alpha );
};

#endif  // __SCANNER_HH

