#ifndef __SOCKET_HH
#define __SOCKET_HH


#define BUFFERSIZE 16384
                         

#include <netinet/in.h>
#include "../misc/TString.hh"


class TSocket
{  
  public :
  //Constructor
  TSocket();
  TSocket( int portnumber ); 
  //Destructor
  ~TSocket();

  int getDescriptor() { return nsd; };

  void setPort(int port);

  //Create the  Serversocket (ONLY for the server)
  int create();

  //Waiting for Clients connecting to Serversocket (ONLY for the server)
  //Returning socketdescriptor used for commucniation
  //if it fails the return is -1
  int select(); 

  // Connect to a existing Socket (ONLY for the Client) 
  // Returning socketdescriptor used for commucniation
  // if it fails the return is -1
  int connect(TString host);

  bool connected(); //Returns bConnected (ONLY for the Client)

  //closes the communicationsocket (ONLY for the client)
  bool close();
  
  //closes the socket sd 
  bool close(int sd);
  
  //Send a  String through the socket sd
  bool send(int sd, TString);

  //Sends a String through the Communication Socket (ONLY for client)
  bool send(TString);

//Send a  line\n through the socket sd
  bool sendln(int sd, TString);

  //Sends a line\n through the Communication Socket (ONLY for client)
  bool sendln(TString);  

  //Receives a line\n through the Communication Socket (ONLY for Client)
  int recvln(TString &Result); 

  //Receives a line\n through the Socket sd
  int recvln(int sd, TString &Result); 

  //Receives a string through the Socket sd
  //Returning received Bytes / -1 = Error
  int recv(int sd, TString &Result);

  //Receives a string through the Communication-Socket  (ONLY for CLIENT)
  //Returning received Bytes / -1 = Error
  int recv(TString &Result);

  
  protected :
  bool bconnected;                //Is the Communication-Connection etablished ?
  bool bserver;                   //Is the ServerSocket open ?
  int nport;                      //Portnumber
  int nsd;                        //Socketdescriptor for the communication
  int serverSocket;                  //Descriptor for Server waiting for clientconnections
  struct sockaddr_in  socketAddr; //Socketaddress

  int  len;
  fd_set readySockets;
	struct timeval *pSocketTimer;
};

#endif //__SOCKET_HH

